// define directions and arguments for this load of crap,
// note that this repeats pretty much everything that is
// better defined in the layer below .... oh well
#include <sys/types.h>
#include <sys/stat.h>
#include <fcntl.h>
#include <sys/ioctl.h>
#include <stdio.h>
#include <unistd.h>
#include <fcntl.h>
#include <signal.h>
#include <pi_user.h>

#define PI_LIB_FUN		0x00000100
#define PI_GET_QMC		0x00000200
#define PI_SET_QMC		0x00000400

#define PI_E_C			0x00001000
#define PI_E_CR			0x00002000
#define PI_E_CWR		0x00004000
#define PI_E_CW			0x00008000
#define PI_E_CWW		0x00010000
#define PI_CMD_BIT		0x000000ff
#define PI_TABLE_BIT		0x000001ff

#define PI_E_CMD		int

// the maximum size of a pi report in this version of the driver (actually I think 64 is safe - matt)
#define PI_REPORT_SIZE		128
#define PI_ERROR_REPORT		"ERROR"

void pi_execute(PI_AXIS, PI_E_CMD, int, char *);
// define PI_constants that really map to setQMC calls 
// see pi_cmd.h - this repeats and expands the header there
// this may be merged with pi_cmd.h
// send commands with no data (defined for execute)
#define PI_CI	PI_E_C + PI_CLEAR_INTERRUPT 
#define PI_NO	PI_E_C + PI_NO_OPERATION 
#define PI_RT	PI_E_C + PI_RESET 
#define PI_UP	PI_E_C + PI_UPDATE 

// commands that get something but require an argument (defined for execute)
#define PI_GB	PI_E_WR + PI_GET_QMC + PI_GET_BREAKPOINT
#define PI_GBV	PI_E_WR + PI_GET_QMC + PI_GET_BREAKPOINT_VALUE 

// command that get something (defined for execute)
#define PI_GA	PI_E_CR + PI_GET_QMC + PI_GET_ACCELERATION 
#define PI_GAS	PI_E_CR + PI_GET_QMC + PI_GET_ACTIVITY_STATUS 
#define PI_TP	PI_E_CR + PI_GET_QMC + PI_GET_ACTUAL_POSITION 
#define PI_TV	PI_E_CR + PI_GET_QMC + PI_GET_ACTUAL_VELOCITY 
#define PI_GSM	PI_E_CR + PI_GET_QMC + PI_GET_AUTO_STOP_MODE 
#define PI_GAM	PI_E_CR + PI_GET_QMC + PI_GET_AXIS_MODE 
#define PI_GIP	PI_E_CR + PI_GET_QMC + PI_GET_CAPTURE_VALUE 
#define PI_GPP	PI_E_CR + PI_GET_QMC + PI_GET_COMMANDED_POSITION 
#define PI_GPV	PI_E_CR + PI_GET_QMC + PI_GET_COMMANDED_VELOCITY 
#define PI_TD	PI_E_CR + PI_GET_QMC + PI_GET_DECELERATION 
#define PI_GES	PI_E_CR + PI_GET_QMC + PI_GET_EVENT_STATUS 
#define PI_GGM	PI_E_CR + PI_GET_QMC + PI_GET_GEAR_MASTER 
#define PI_GGR	PI_E_CR + PI_GET_QMC + PI_GET_GEAR_RATIO 
#define PI_GSI	PI_E_CR + PI_GET_QMC + PI_GET_INTEGRAL 
#define PI_GL	PI_E_CR + PI_GET_QMC + PI_GET_INTEGRATION_LIMIT 
#define PI_GIA	PI_E_CR + PI_GET_QMC + PI_GET_INTERRUPT_AXIS
#define PI_GIM	PI_E_CR + PI_GET_QMC + PI_GET_INTERRUPT_MASK 
#define PI_GJ	PI_E_CR + PI_GET_QMC + PI_GET_JERK 
#define PI_GD	PI_E_CR + PI_GET_QMC + PI_GET_KD 
#define PI_GI	PI_E_CR + PI_GET_QMC + PI_GET_KI 
#define PI_GP	PI_E_CR + PI_GET_QMC + PI_GET_KP 
#define PI_GF	PI_E_CR + PI_GET_QMC + PI_GET_KVFF 
#define PI_GLM	PI_E_CR + PI_GET_QMC + PI_GET_LIMIT_SWITCH_MODE 
#define PI_GMM	PI_E_CR + PI_GET_QMC + PI_GET_MOTOR_MODE 
#define PI_GOM	PI_E_CR + PI_GET_QMC + PI_GET_OUTPUT_MODE 
#define PI_TT	PI_E_CR + PI_GET_QMC + PI_GET_POSITION 
#define PI_TF	PI_E_CR + PI_GET_QMC + PI_GET_POSITION_ERROR
#define PI_GPE	PI_E_CR + PI_GET_QMC + PI_GET_POSITION_ERROR_LIMIT
#define PI_GPM	PI_E_CR + PI_GET_QMC + PI_GET_PROFILE_MODE 
#define PI_GT	PI_E_CR + PI_GET_QMC + PI_GET_SAMPLE_TIME 
#define PI_GSS	PI_E_CR + PI_GET_QMC + PI_GET_SIGNAL_SENSE 
#define PI_GTI	PI_E_CR + PI_GET_QMC + PI_GET_TIME 
#define PI_TY	PI_E_CR + PI_GET_QMC + PI_GET_VELOCITY 
#define PI_VE	PI_E_CR + PI_GET_QMC + PI_GET_VERSION 

// commands that set something (for execute)
#define PI_MUP	PI_E_CW + PI_SET_QMC + PI_MULTI_UPDATE 
#define PI_SA	PI_E_CW + PI_SET_QMC + PI_SET_ACCELERATION 
#define PI_SSM	PI_E_CW + PI_SET_QMC + PI_SET_AUTO_STOP_MODE 
#define PI_SAM	PI_E_CW + PI_SET_QMC + PI_SET_AXIS_MODE 
#define PI_SCS	PI_E_CW + PI_SET_QMC + PI_SET_CAPTURE_SOURCE 
#define PI_SD	PI_E_CW + PI_SET_QMC + PI_SET_DECELERATION 
#define PI_SEM	PI_E_CW + PI_SET_QMC + PI_SET_ENCODER_MODULUS 
#define PI_SGM	PI_E_CW + PI_SET_QMC + PI_SET_GEAR_MASTER 
#define PI_SGR	PI_E_CW + PI_SET_QMC + PI_SET_GEAR_RATIO 
#define PI_SIM	PI_E_CW + PI_SET_QMC + PI_SET_INTERRUPT_MASK 
#define PI_DL	PI_E_CW + PI_SET_QMC + PI_SET_INTEGRATION_LIMIT 
#define PI_SJ	PI_E_CW + PI_SET_QMC + PI_SET_JERK 
#define PI_DP	PI_E_CW + PI_SET_QMC + PI_SET_KP 
#define PI_DI	PI_E_CW + PI_SET_QMC + PI_SET_KI 
#define PI_DD	PI_E_CW + PI_SET_QMC + PI_SET_KD 
#define PI_DF	PI_E_CW + PI_SET_QMC + PI_SET_KVFF 
#define PI_RES	PI_E_C + PI_SET_QMC + PI_RESET_EVENT_STATUS
#define PI_SB	PI_E_CW + PI_SET_QMC + PI_SET_BREAKPOINT
#define PI_SBV	PI_E_CW + PI_SET_QMC + PI_SET_BREAKPOINT_VALUE 
#define PI_SLM	PI_E_CW + PI_SET_QMC + PI_SET_LIMIT_SWITCH_MODE 
#define PI_SMO	PI_E_CW + PI_SET_QMC + PI_SET_MOTOR_COMMAND 
#define PI_SMM	PI_E_CW + PI_SET_QMC + PI_SET_MOTOR_MODE 
#define PI_SOM	PI_E_CW + PI_SET_QMC + PI_SET_OUTPUT_MODE 
#define PI_SP	PI_E_CW + PI_SET_QMC + PI_SET_POSITION
#define PI_SPE	PI_E_CW + PI_SET_QMC + PI_SET_POSITION_ERROR_LIMIT 
#define PI_SPM	PI_E_CW + PI_SET_QMC + PI_SET_PROFILE_MODE 
#define PI_SST	PI_E_CW + PI_SET_QMC + PI_SET_SAMPLE_TIME 
#define PI_SSS	PI_E_CW + PI_SET_QMC + PI_SET_SIGNAL_SENSE 
#define PI_SV	PI_E_CW + PI_SET_QMC + PI_SET_VELOCITY 

#define PI_TX	PI_GIP	// alias for GIP
#define PI_TA	PI_GA	// alias for GA
// define PI_constants that are really just library calls
// these aren't motion chipset commands, they are emulated by the execute library
// 
// I will redefine PI_the numbers so they make some sense
// commands that call library functions (for execute library not PI_USER!)
// command numbers here begin with 0, this with #define PI_LIB_FUN makes a unique list !
#define PI_AB	PI_E_C + PI_LIB_FUN + 0x00	// calls fAB NOT PI_READ_ANALOG 0xef

#define PI_BN	PI_E_C + PI_LIB_FUN + 0x01	// brake on calls fBN
#define PI_BF	PI_E_C + PI_LIB_FUN + 0x02	// brake off calls fBF

#define PI_CN	PI_E_CW + PI_LIB_FUN + 0x03	// calls fCN NOT PI_GET_MOTION_COMPLETE_MODE 0xec
#define PI_CF	PI_E_CW + PI_LIB_FUN + 0x04	// calls cCF NOT PI_SET_AXIS_OUT_SOURCE 0xed

#define PI_DH	PI_E_C + PI_LIB_FUN + 0x05	// calls fDH NOT PI_SET_ACTUAL_POSITION 0x4d
#define PI_DLL	PI_E_C + PI_LIB_FUN + 0x06	// calls fDLL calls IGet_Version which just returns a version number

#define PI_FEP	PI_E_C + PI_LIB_FUN + 0x07	// unsupported (0.52) use pi_find_home();
#define PI_FEN	PI_E_C + PI_LIB_FUN + 0x08	// unsupported (0.52) use pi_find_home();

#define PI_GH	PI_E_C + PI_LIB_FUN + 0x09	// calls fGH / goes to 0
 
#define PI_MR	PI_E_CW + PI_LIB_FUN + 0x10	// calls fMR / move relative - sets position and updates
#define PI_MA	PI_E_CW + PI_LIB_FUN + 0x11	// calls fMA / move absolute - sets position and updates
 
#define PI_REC	PI_E_C + PI_LIB_FUN + 0x12	// calls fREC calls IRecover a move off limits function
#define PI_RET	PI_E_C + PI_LIB_FUN + 0x13	// calls fRET which calls:
						// setQMC(RESET_EVENT_STATUS, ax, 0);
						// gets and sets the velocity and position
						// setQMC(SET_MOTOR_MODE, ax, 1);
						// setQMC(UPDATE, ax, 0);

#define PI_ST	PI_E_C + PI_LIB_FUN + 0x14	// calls fST NOT PI_GET_PHASE_INITIALIZE_MODE 0xe5

#define PI_TC	PI_E_CR + PI_LIB_FUN + 0x15	// calls fTC NOT PI_SET_MOTION_COMPLETE_MODE 0xeb
#define PI_TE	PI_E_CR + PI_LIB_FUN + 0x16	// calls fTE NOT PI_SET_PHASE_PRESCALE 0xe6

#define PI_WA	PI_E_C + PI_LIB_FUN + 0x17	// calls fWA waits for a set time!
#define PI_WC	PI_E_C + PI_LIB_FUN + 0x18	// calls fWC (getQMCA(READ_IO, 0, 0, &port); until bit is high)
#define PI_WS	PI_E_C + PI_LIB_FUN + 0x19	// calls sWS waits for axis to stop
#define PI_WT	PI_E_CW + PI_LIB_FUN + 0x20	// calls fWT (waitstop then setQMCA(WRITE_IO, 0, 0, v);)


// allow the definition of non PI_ prefixed constants
#ifdef PI_EXECUTE_DEFINES
#define NO 	PI_NO
#define SV 	PI_SV
#define SJ 	PI_SJ
#define UP 	PI_UP
#define GPP 	PI_GPP
#define GPV 	PI_GPV
#define DP 	PI_DP
#define DI 	PI_DI
#define DD 	PI_DD
#define DF 	PI_DF
#define SIM 	PI_SIM
#define GES 	PI_GES
#define GIP 	PI_GIP
#define TX 	PI_TX
#define TP 	PI_TP
#define SST 	PI_SST
#define RT 	PI_RT
#define GTI 	PI_GTI
#define TT 	PI_TT
#define TY 	PI_TY
#define GA 	PI_GA
#define TA 	PI_TA
#define GP 	PI_GP
#define GI 	PI_GI
#define GD 	PI_GD
#define GF 	PI_GF
#define GIM 	PI_GIM
#define GJ 	PI_GJ
#define GGR 	PI_GGR
#define MUP 	PI_MUP
#define GT 	PI_GT
#define GOM 	PI_GOM
#define SLM 	PI_SLM
#define GLM 	PI_GLM
#define SAM 	PI_SAM
#define GAM 	PI_GAM
#define SEM 	PI_SEM
#define VE 	PI_VE
#define SA 	PI_SA
#define SMO 	PI_SMO
#define SD 	PI_SD
#define TD 	PI_TD
#define DL 	PI_DL
#define GL 	PI_GL
#define SPE 	PI_SPE
#define GPE 	PI_GPE
#define TF 	PI_TF
#define GSI 	PI_GSI
#define SPM 	PI_SPM
#define GPM 	PI_GPM
#define SSS 	PI_SSS
#define GSS 	PI_GSS
#define GAS 	PI_GAS
#define CI 	PI_CI
#define TV 	PI_TV
#define SGM 	PI_SGM
#define GGM 	PI_GGM
#define SSM 	PI_SSM
#define GSM 	PI_GSM
#define GB 	PI_GB
#define GBV 	PI_GBV
#define SCS 	PI_SCS
#define SMM 	PI_SMM
#define GMM 	PI_GMM
#define SOM 	PI_SOM
#define WS 	PI_WS
#define ST 	PI_ST
#define TE 	PI_TE
#define WA 	PI_WA
#define TC 	PI_TC
#define CN 	PI_CN
#define CF 	PI_CF
#define AB 	PI_AB
#define REC 	PI_REC
#define DLL 	PI_DLL
#define SP 	PI_SP
#define RET 	PI_RET
#define WC 	PI_WC
#define WT 	PI_WT
#define FEP 	PI_FEP
#define FEN 	PI_FEN
#define BN 	PI_BN
#define BF 	PI_BF
#define GIA 	PI_GIA
#define MR 	PI_MR
#define MA 	PI_MA
#define GH 	PI_GH
#define SGR 	PI_SGR
#define DH 	PI_DH
#define SB 	PI_SB
#define SBV 	PI_SBV
#endif
