/* (c) Matt Clark Feb 2003
 *
 * You are free to copy, change and distribute this software BUT
 * you cannot charge for it (even if you change it).
 *
 * The use of this code in your code conveys no rights over
 * your code.  So, if you wish to charge for a program that uses
 * this library that is fine.  You will have to distribute the
 * library free of charge.
 *
 * This library is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Lesser General Public
 * License as published by the Free Software Foundation; either
 * version 2.1 of the License, or (at your option) any later version.
 *
 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Lesser General Public License for more details.
 *
 * You should have received a copy of the GNU Lesser General Public
 * License along with this library; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 *
 * Matt.Clark@Nottingham.ac.uk
 */
#include <stdio.h>
#include <stdlib.h>
#include "pi_user.h"

#define PI_POSITION_FILE "/etc/pi_stage/position"

int main(void){
int position[4],i,ok,axis;
FILE *out;
	// check on the existing file
	if(access(PI_POSITION_FILE, F_OK)==0){
		printf("pi_recall_pos: %s exists (ok)\n",PI_POSITION_FILE);
		}
	else{
		printf("pi_recall_pos: %s doesn't exist (bad)\n",PI_POSITION_FILE);
		fprintf(stderr,"(STDERR) pi_recall_pos: can't find %s aborting\n",PI_POSITION_FILE);
		printf("(STDOUT) pi_recall_pos: can't find %s aborting\n",PI_POSITION_FILE);
		exit(1);
		}
	if(access(PI_POSITION_FILE, R_OK)==0){
		printf("pi_recall_pos: %s can be read (good)\n",PI_POSITION_FILE);
		}
	else{
		printf("pi_recall_pos: %s can't be read (bad)\n",PI_POSITION_FILE);
		fprintf(stderr,"(STDERR) pi_recall_pos: can't read %s aborting\n",PI_POSITION_FILE);
		printf("(STDOUT) pi_recall_pos: can't read %s aborting\n",PI_POSITION_FILE);
		exit(1);
		}
	
	out=fopen(PI_POSITION_FILE,"r");

	if(out<0){
		printf("pi_recall_pos: %s can't be open (bad)\n",PI_POSITION_FILE);
		fprintf(stderr,"(STDERR) pi_recall_pos: can't open %s aborting\n",PI_POSITION_FILE);
		printf("(STDOUT) pi_recall_pos: can't open %s aborting\n",PI_POSITION_FILE);
		exit(1);
		}
		
	ok=pi_openboard();  // already calls init board
	if(ok==FALSE){
		fprintf(stderr,"(STDERR) pi_recall_pos: Failed to open /dev/pi_stage (is the device driver installed?)\n");
		printf("(STDOUT) pi_recall_pos: Failed to open /dev/pi_stage (is the device driver installed?)\n");
		exit(2);
		}

	axis=pi_axis_installed();
	
	for(i=0;i<axis;i++){
		fscanf(out,"%d\n",position+i);
		printf("Axis %d was at %d\n",i,position[i]);
		}
	fclose(out);

	for(i=0;i<axis;i++){
		pi_init_axis(i);
		pi_set_pos(i,position[i]);
		}
	
	pi_closeboard();
	}
	
	
	
