// this table decodes mnemomic constants defined
// for the execute function into mnemomic strings
// define for the reply string, total cheese I know
// but it is here to be functionally compatible with 
// the PI windows drivers.
//
// To facilitate this in the easiest way each mnenomic
// has a unique number which decodes to a string, most
// of the codes are passed straight through to the library
// layer and use set/getQMC to execute the command
// since the code is used as the set/getQMC command 
// these are all defined in the range 0x0000->0x00ff
// since there are only 65 of these commands the table is
// pretty sparse but the 1k bytes (or so) wasted is worth
// it just to make the code simple and compatible with 
// the PMD chipset commands.
// A smaller number (~20 or so) commands are emulated in
// the pi_execute library (although many of these simply
// pass through to being PMD command + something simple).
// All of these are have codes defined between 0x00ff and
// 0x0200.
// Picking a missing number gives NULL - beware!
// In this scheme codes that are duplicates return what
// ever string I coded first - if you want them to have 
// identical behaviour you will either have to find a blank
// entry below 0xff or define a library call (best).
//
// define this to be the size of the table, if you add more
// library calls extend the table accordingly
#define PI_TABLE_SIZE 0x011f



char * pi_table[]={
	// 0x00 0x0f
	"NO", NULL, NULL, NULL,		//	0	1	2	3
	NULL, NULL, NULL, NULL,		//	4	5	6	7
	NULL, NULL, NULL, NULL,		//	8	9	A	B
	NULL, NULL, NULL, NULL,		//	C	D	E	F
	// 0x10-0x1f
	"SP", "SV", NULL, "SJ",
	"SGR", NULL, NULL, NULL,
	NULL, NULL, "UP", NULL,
	NULL, "GPP", "GPV", NULL,
	// 0x1f-0x2f
	NULL, NULL, NULL, NULL,
	NULL, "DP", "DI", "DD",
	NULL, NULL, NULL, "DF",
	NULL, NULL, NULL, "SIM",
	// 0x30-0x3f
	NULL, "GES", NULL, NULL,
	"RES", NULL, "GIP", "TP",
	"SST", "RT", NULL, NULL,
	NULL, NULL, "GTI", NULL,
	// 0x30-0x4f
	NULL, NULL, NULL, NULL,
	NULL, NULL, NULL, NULL,
	NULL, NULL, "TT", "TY",
	"GA", NULL, NULL, NULL,
	// 0x50-0x5f
	"GP", "GI", "GD", "GF",
	NULL, NULL, "GIM", NULL,
	"GJ", "GGR", NULL, "MUP",
	NULL, NULL, NULL, NULL,
	// 0x60-0x6f
	NULL, "GT", NULL, NULL,
	NULL, NULL, NULL, NULL,
	NULL, NULL, NULL, NULL,
	NULL, NULL, "GOM", NULL,
	// 0x70-0x7f
	NULL, NULL, NULL, NULL,
	NULL, NULL, NULL, "SMO",
	NULL, NULL, NULL, NULL,
	NULL, NULL, NULL, NULL,
	// 0x80-0x8f
	"SLM", "GLM", NULL, NULL,
	"GAM", NULL, NULL, "SAM",
	NULL, NULL, NULL, NULL,
	NULL, NULL, NULL, "VE",
	// 0x90-0x9f
	"SA", "SD", "TD", NULL,
	NULL, "DL", "GL", "SPE",
	"GPE", "TE", "GSI", NULL,
	NULL, NULL, NULL, NULL,
	// 0xa0-0xaf
	"SPM", "GPM", "SSS", "GSS",
	NULL, NULL, "GAS", NULL,
	NULL, NULL, "CI", NULL,
	NULL, "TV", "SGM", "GGM",
	// 0xb0-0xbf
	NULL, NULL, NULL, NULL,
	NULL, NULL, NULL, NULL,
	NULL, NULL, NULL, NULL,
	NULL, NULL, NULL, NULL,
	// 0xc0-0xcf
	NULL, NULL, NULL, NULL,
	NULL, NULL, NULL, NULL,
	NULL, NULL, NULL, NULL,
	NULL, NULL, NULL, NULL,
	// 0xd0-0xdf
	NULL, NULL, "SSM", "GSM",
	"SB", "GB", "SBV", "GBV",
	"SCS", NULL, NULL, NULL,
	"SMM", "GMM", NULL, NULL,
	// 0xe0-0xef
	"SOM", "GIA", NULL, NULL,
	NULL, NULL, NULL, NULL,
	NULL, NULL, NULL, NULL,
	NULL, NULL, NULL, NULL,
	// 0xf0-0xff
	NULL, NULL, NULL, NULL,
	NULL, NULL, NULL, NULL,
	NULL, NULL, NULL, NULL,
	NULL, NULL, NULL, NULL,
	// Now then all the strings above 0xff are library calls 
	// 0x0100-0x010f
	"AB", "BN", "BF", "CN",
	"CF", "DH", "DLL", "FEP",
	"FEN", "GH", "MR", "MA",
	"REC", "RET", "ST", "TC",
	// 0x0110-0x011f
	"TE", "WA", "WC", "WS",
       	"WT",	NULL, NULL, NULL,
	NULL, NULL, NULL, NULL,
	NULL, NULL, NULL, NULL,
	};
